"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;
var _react = _interopRequireWildcard(require("react"));
var _propTypes = _interopRequireDefault(require("prop-types"));
var _i18n = require("@edx/frontend-platform/i18n");
var _paragon = require("@edx/paragon");
var _FilterBlock = _interopRequireDefault(require("../FilterBlock"));
var _utils = require("../utils");
var _messages = _interopRequireDefault(require("./messages"));
require("./index.scss");
var _jsxRuntime = require("react/jsx-runtime");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function (nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }
function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || typeof obj !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }
const SearchBlocks = _ref => {
  let {
    blocks,
    onSearchFilter,
    searchInputValue = '',
    onBlockSelected
  } = _ref;
  const intl = (0, _i18n.useIntl)();
  const [searchField, setSearchField] = (0, _react.useState)(searchInputValue);
  const [blocksFilteredItems, setBlocksFilteredItems] = (0, _react.useState)(null);
  const blocksFilteredItemsFormat = blocksFilteredItems ? Object.keys(blocksFilteredItems) : [];
  const handleSearchBlock = value => {
    setSearchField(value);
  };
  const handleSelectedBlock = block => {
    onBlockSelected(block);
  };
  (0, _react.useEffect)(() => {
    if (searchField.trim()) {
      const blockFilter = (0, _utils.filterBlocksByText)(searchField, blocks);
      setBlocksFilteredItems(blockFilter);
      onSearchFilter(true);
    } else {
      setBlocksFilteredItems(null);
      onSearchFilter(false);
    }
  }, [searchField]);
  return /*#__PURE__*/(0, _jsxRuntime.jsxs)("div", {
    children: [/*#__PURE__*/(0, _jsxRuntime.jsx)(_paragon.SearchField, {
      placeholder: "Search course pages",
      className: "my-4",
      onChange: handleSearchBlock,
      value: searchField,
      "data-testid": "search-field",
      onSubmit: () => null
    }), searchField.trim() && /*#__PURE__*/(0, _jsxRuntime.jsx)("p", {
      className: "h5 ml-1 text-gray-500",
      children: intl.formatMessage(_messages.default.searchBlocksResultMessages, {
        searchField: `"${searchField}"`
      })
    }), blocksFilteredItemsFormat.length > 0 && /*#__PURE__*/(0, _jsxRuntime.jsx)("div", {
      className: "blocks-filter-container",
      children: blocksFilteredItemsFormat.map(key => /*#__PURE__*/(0, _jsxRuntime.jsx)(_FilterBlock.default, {
        block: blocks[key],
        onBlockFilterClick: handleSelectedBlock
      }, key))
    })]
  });
};
SearchBlocks.defaultProps = {
  onSearchFilter: () => {},
  onBlockSelected: () => {},
  searchInputValue: ''
};
const blockShape = _propTypes.default.shape({
  id: _propTypes.default.string.isRequired,
  blockId: _propTypes.default.string.isRequired,
  lmsWebUrl: _propTypes.default.string.isRequired,
  legacyWebUrl: _propTypes.default.string.isRequired,
  studentViewUrl: _propTypes.default.string.isRequired,
  type: _propTypes.default.string.isRequired,
  displayName: _propTypes.default.string.isRequired,
  children: _propTypes.default.arrayOf(_propTypes.default.string)
});
SearchBlocks.propTypes = {
  blocks: _propTypes.default.objectOf(blockShape).isRequired,
  onSearchFilter: _propTypes.default.func,
  searchInputValue: _propTypes.default.string,
  onBlockSelected: _propTypes.default.func
};
var _default = exports.default = SearchBlocks;
//# sourceMappingURL=index.js.map